#execfile "filename.py"

import random
from genetic_optimize import *
from random_optimize import *

TARGET_STRING='Hello world'
target_length=len(TARGET_STRING)

def string_fitness (individual):
    fitness=0
    for ipos in range (0,target_length):
        fitness+=abs( ord(individual[ipos]) - ord (TARGET_STRING[ipos]) )
    return fitness


# Mutation Operation
def mutate_string(individual, params=None):
    ipos=random.randint(0,target_length-1)

    #mutation changes character at random to any available character from 32 (space) to 90 (Z)
    
    rchar=chr(random.randint(0,32000)%90 + 32)

    individual=individual[0:ipos]+rchar+individual[(ipos+1):]
    
    return individual


#Mate operation (crossover)
def string_crossover(p1,p2, params=None):
    ipos=random.randint(1,target_length-2)    
    return p1[0:ipos]+p2[ipos:]


#build initial population
def init_strings_population (population_size):
    population=[]
    for i in range (0,population_size):
        individual=''
        for j in range (0, target_length):
	    individual+=chr(random.randint(32,90))
        population.append(individual)
    return population
            
  